#define tam 4
mtype = {idle, act, lider};
int msgs[tam];
mtype estado[tam];

proctype nodo(int id; int pr){
  int sig = (id + 1) % tam;
  do
  :: atomic{estado[id] == idle ->
                     estado[id] = act; msgs[sig] = pr;}
  :: atomic{(estado[id] == act) && (msgs[id] == pr) ->
                     msgs[id] = 0; estado[id] = lider;}
  :: atomic{(estado[id] == act) && (msgs[id] != 0) &&
            (msgs[id] > pr) && (msgs[sig] == 0) ->
                     msgs[sig] = msgs[id]; msgs[id] = 0;}
  :: atomic{(estado[id] == act) && (msgs[id] != 0) && (msgs[id] < pr) ->
                     msgs[id] = 0;}
  od
}

proctype monitor(){
  assert((estado[1] != lider) && (estado[2] != lider) && (estado[3] != lider))
}

ltl lid {<> [] (estado[0] == lider)}

init {
  atomic{
    msgs[0] = 0;
    msgs[1] = 0;
    msgs[2] = 0;
    msgs[3] = 0;
    estado[0] = idle;
    estado[1] = idle;
    estado[2] = idle;
    estado[3] = idle;
    run nodo(0, 7);
    run nodo(1, 4);
    run nodo(2, 2);
    run nodo(3, 1);
  }
}
