mtype = {syn, synack, ack};
typedef Msg {
        mtype name;
        byte seq;
        byte ackn;
};
Msg canales[2];
byte serverState[2];

proctype server(){
  byte seq = 0;
  serverState[0] = 0;
  serverState[1] = 0;
  byte last[2];
  do
  :: seq < 5 -> seq = seq + 1;
  :: canales[0].name == syn ->
            		canales[0].name = synack;
            		canales[0].ackn = canales[0].seq + 1
            		last[0] = seq;
            		serverState[0] = 1;
  :: canales[1].name == syn ->
            		canales[1].name = synack;
            		canales[1].ackn = canales[1].seq + 1
            		last[1] = seq;
            		serverState[1] = 1;
  :: canales[0].name == ack && serverState[0] == 1 ->
            		serverState[0] = 2;
  :: canales[1].name == ack && serverState[1] == 1 ->
            		serverState[1] = 2;
  od
}

proctype client(byte id){
  byte seq = 0;
  byte state = 0;
  int last = 0;
  do
  :: seq < 5 -> seq = seq + 1;
  :: state == 0 ->
            		canales[id].name = syn;
            		canales[id].seq = seq;
            		last = seq;
            		state = 1;
  :: state == 1 && canales[id].name == synack && canales[id].ackn == last + 1 ->
            		canales[id].name = ack;
            		canales[id].ackn = canales[id].seq + 1;
            		canales[id].seq = last + 1;
            		last = last + 1;
            		state = 2
  od
}

ltl conectados { <> [] (serverState[0] == 2 && serverState[1] == 2) }

init {atomic{ run server(); run client(0); run client(1);} }
